#import "UniversalCanvasModule.h"
#import <React/RCTEventDispatcher.h>
@import Firebase;
@import GoogleSignIn;

@implementation UniversalCanvas

RCT_EXPORT_MODULE();

@synthesize bridge = _bridge;

+ (BOOL)application:(nonnull UIApplication *)application
            openURL:(nonnull NSURL *)url
            options:(nonnull NSDictionary<NSString *, id> *)options {
    return [[GIDSignIn sharedInstance] handleURL:url
                               sourceApplication:options[UIApplicationOpenURLOptionsSourceApplicationKey]
                                      annotation:options[UIApplicationOpenURLOptionsAnnotationKey]];
}

RCT_EXPORT_METHOD(initialize:(NSDictionary*)config) {
    [FIRApp configure];
    [GIDSignIn sharedInstance].clientID = [FIRApp defaultApp].options.clientID;
    [GIDSignIn sharedInstance].delegate = self;
}

RCT_EXPORT_METHOD(deleteCurrentUser:(RCTResponseSenderBlock *)callback) {
}

RCT_EXPORT_METHOD(signOut:(RCTResponseSenderBlock *)callback) {
    NSError *signOutError;
    BOOL status = [[FIRAuth auth] signOut:&signOutError];
    if (!status) {
        NSLog(@"Error signing out: %@", signOutError);
        return;
    }
}

RCT_EXPORT_METHOD(invokeGoogleAuth) {
    [GIDSignIn sharedInstance].uiDelegate = self;
    [[GIDSignIn sharedInstance] signIn];
}

- (void)signIn:(GIDSignIn *)signIn didSignInForUser:(GIDGoogleUser *)user withError:(NSError *)error {
    if (error == nil) {
        GIDAuthentication *authentication = user.authentication;
        FIRAuthCredential *credential = [FIRGoogleAuthProvider credentialWithIDToken:authentication.idToken
                                                                         accessToken:authentication.accessToken];
        // ...
    } else {
        // ...
    }

}
- (void)signIn:(GIDSignIn *)signIn didDisconnectWithUser:(GIDGoogleUser *)user withError:(NSError *)error {
    // Perform any operations when the user disconnects from app here.
    // ...
}

@end
